# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetConfigResult',
    'AwaitableGetConfigResult',
    'get_config',
    'get_config_output',
]

@pulumi.output_type
class GetConfigResult:
    """
    A collection of values returned by getConfig.
    """
    def __init__(__self__, embed_metadata=None, id=None, scrub_audio_tags=None, update_covers=None, write_audio_tags=None, write_book_tags=None):
        if embed_metadata and not isinstance(embed_metadata, bool):
            raise TypeError("Expected argument 'embed_metadata' to be a bool")
        pulumi.set(__self__, "embed_metadata", embed_metadata)
        if id and not isinstance(id, int):
            raise TypeError("Expected argument 'id' to be a int")
        pulumi.set(__self__, "id", id)
        if scrub_audio_tags and not isinstance(scrub_audio_tags, bool):
            raise TypeError("Expected argument 'scrub_audio_tags' to be a bool")
        pulumi.set(__self__, "scrub_audio_tags", scrub_audio_tags)
        if update_covers and not isinstance(update_covers, bool):
            raise TypeError("Expected argument 'update_covers' to be a bool")
        pulumi.set(__self__, "update_covers", update_covers)
        if write_audio_tags and not isinstance(write_audio_tags, str):
            raise TypeError("Expected argument 'write_audio_tags' to be a str")
        pulumi.set(__self__, "write_audio_tags", write_audio_tags)
        if write_book_tags and not isinstance(write_book_tags, str):
            raise TypeError("Expected argument 'write_book_tags' to be a str")
        pulumi.set(__self__, "write_book_tags", write_book_tags)

    @property
    @pulumi.getter(name="embedMetadata")
    def embed_metadata(self) -> bool:
        """
        Embed metadata in book files.
        """
        return pulumi.get(self, "embed_metadata")

    @property
    @pulumi.getter
    def id(self) -> int:
        """
        Metadata Config ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="scrubAudioTags")
    def scrub_audio_tags(self) -> bool:
        """
        Scrub audio tags.
        """
        return pulumi.get(self, "scrub_audio_tags")

    @property
    @pulumi.getter(name="updateCovers")
    def update_covers(self) -> bool:
        """
        Update covers.
        """
        return pulumi.get(self, "update_covers")

    @property
    @pulumi.getter(name="writeAudioTags")
    def write_audio_tags(self) -> str:
        """
        Write audio tags.
        """
        return pulumi.get(self, "write_audio_tags")

    @property
    @pulumi.getter(name="writeBookTags")
    def write_book_tags(self) -> str:
        """
        Write book tags.
        """
        return pulumi.get(self, "write_book_tags")


class AwaitableGetConfigResult(GetConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConfigResult(
            embed_metadata=self.embed_metadata,
            id=self.id,
            scrub_audio_tags=self.scrub_audio_tags,
            update_covers=self.update_covers,
            write_audio_tags=self.write_audio_tags,
            write_book_tags=self.write_book_tags)


def get_config(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConfigResult:
    """
    <!-- subcategory:Metadata -->Metadata Config.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_readarr as readarr

    example = readarr.Metadata.get_config()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('readarr:Metadata/getConfig:getConfig', __args__, opts=opts, typ=GetConfigResult).value

    return AwaitableGetConfigResult(
        embed_metadata=pulumi.get(__ret__, 'embed_metadata'),
        id=pulumi.get(__ret__, 'id'),
        scrub_audio_tags=pulumi.get(__ret__, 'scrub_audio_tags'),
        update_covers=pulumi.get(__ret__, 'update_covers'),
        write_audio_tags=pulumi.get(__ret__, 'write_audio_tags'),
        write_book_tags=pulumi.get(__ret__, 'write_book_tags'))


@_utilities.lift_output_func(get_config)
def get_config_output(opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetConfigResult]:
    """
    <!-- subcategory:Metadata -->Metadata Config.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_readarr as readarr

    example = readarr.Metadata.get_config()
    ```
    """
    ...
