# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['GoodreadsBookshelvesArgs', 'GoodreadsBookshelves']

@pulumi.input_type
class GoodreadsBookshelvesArgs:
    def __init__(__self__, *,
                 access_token: pulumi.Input[str],
                 access_token_secret: pulumi.Input[str],
                 username: pulumi.Input[str],
                 add_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 include_health_warnings: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 on_author_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete_for_upgrade: Optional[pulumi.Input[bool]] = None,
                 on_release_import: Optional[pulumi.Input[bool]] = None,
                 on_upgrade: Optional[pulumi.Input[bool]] = None,
                 remove_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 request_token_secret: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a GoodreadsBookshelves resource.
        :param pulumi.Input[str] access_token: Access token.
        :param pulumi.Input[str] access_token_secret: Access token secret.
        :param pulumi.Input[str] username: Username.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] add_ids: Add IDs.
        :param pulumi.Input[bool] include_health_warnings: Include health warnings.
        :param pulumi.Input[str] name: Notification name.
        :param pulumi.Input[bool] on_author_delete: On author deleted flag.
        :param pulumi.Input[bool] on_book_delete: On book delete flag.
        :param pulumi.Input[bool] on_book_file_delete: On book file delete flag.
        :param pulumi.Input[bool] on_book_file_delete_for_upgrade: On book file delete for upgrade flag.
        :param pulumi.Input[bool] on_release_import: On release import flag.
        :param pulumi.Input[bool] on_upgrade: On upgrade flag.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remove_ids: Remove IDs.
        :param pulumi.Input[str] request_token_secret: Request token secret.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[str] user_id: User ID.
        """
        pulumi.set(__self__, "access_token", access_token)
        pulumi.set(__self__, "access_token_secret", access_token_secret)
        pulumi.set(__self__, "username", username)
        if add_ids is not None:
            pulumi.set(__self__, "add_ids", add_ids)
        if include_health_warnings is not None:
            pulumi.set(__self__, "include_health_warnings", include_health_warnings)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if on_author_delete is not None:
            pulumi.set(__self__, "on_author_delete", on_author_delete)
        if on_book_delete is not None:
            pulumi.set(__self__, "on_book_delete", on_book_delete)
        if on_book_file_delete is not None:
            pulumi.set(__self__, "on_book_file_delete", on_book_file_delete)
        if on_book_file_delete_for_upgrade is not None:
            pulumi.set(__self__, "on_book_file_delete_for_upgrade", on_book_file_delete_for_upgrade)
        if on_release_import is not None:
            pulumi.set(__self__, "on_release_import", on_release_import)
        if on_upgrade is not None:
            pulumi.set(__self__, "on_upgrade", on_upgrade)
        if remove_ids is not None:
            pulumi.set(__self__, "remove_ids", remove_ids)
        if request_token_secret is not None:
            pulumi.set(__self__, "request_token_secret", request_token_secret)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter(name="accessToken")
    def access_token(self) -> pulumi.Input[str]:
        """
        Access token.
        """
        return pulumi.get(self, "access_token")

    @access_token.setter
    def access_token(self, value: pulumi.Input[str]):
        pulumi.set(self, "access_token", value)

    @property
    @pulumi.getter(name="accessTokenSecret")
    def access_token_secret(self) -> pulumi.Input[str]:
        """
        Access token secret.
        """
        return pulumi.get(self, "access_token_secret")

    @access_token_secret.setter
    def access_token_secret(self, value: pulumi.Input[str]):
        pulumi.set(self, "access_token_secret", value)

    @property
    @pulumi.getter
    def username(self) -> pulumi.Input[str]:
        """
        Username.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: pulumi.Input[str]):
        pulumi.set(self, "username", value)

    @property
    @pulumi.getter(name="addIds")
    def add_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Add IDs.
        """
        return pulumi.get(self, "add_ids")

    @add_ids.setter
    def add_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "add_ids", value)

    @property
    @pulumi.getter(name="includeHealthWarnings")
    def include_health_warnings(self) -> Optional[pulumi.Input[bool]]:
        """
        Include health warnings.
        """
        return pulumi.get(self, "include_health_warnings")

    @include_health_warnings.setter
    def include_health_warnings(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "include_health_warnings", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Notification name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="onAuthorDelete")
    def on_author_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        On author deleted flag.
        """
        return pulumi.get(self, "on_author_delete")

    @on_author_delete.setter
    def on_author_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_author_delete", value)

    @property
    @pulumi.getter(name="onBookDelete")
    def on_book_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        On book delete flag.
        """
        return pulumi.get(self, "on_book_delete")

    @on_book_delete.setter
    def on_book_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_book_delete", value)

    @property
    @pulumi.getter(name="onBookFileDelete")
    def on_book_file_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        On book file delete flag.
        """
        return pulumi.get(self, "on_book_file_delete")

    @on_book_file_delete.setter
    def on_book_file_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_book_file_delete", value)

    @property
    @pulumi.getter(name="onBookFileDeleteForUpgrade")
    def on_book_file_delete_for_upgrade(self) -> Optional[pulumi.Input[bool]]:
        """
        On book file delete for upgrade flag.
        """
        return pulumi.get(self, "on_book_file_delete_for_upgrade")

    @on_book_file_delete_for_upgrade.setter
    def on_book_file_delete_for_upgrade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_book_file_delete_for_upgrade", value)

    @property
    @pulumi.getter(name="onReleaseImport")
    def on_release_import(self) -> Optional[pulumi.Input[bool]]:
        """
        On release import flag.
        """
        return pulumi.get(self, "on_release_import")

    @on_release_import.setter
    def on_release_import(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_release_import", value)

    @property
    @pulumi.getter(name="onUpgrade")
    def on_upgrade(self) -> Optional[pulumi.Input[bool]]:
        """
        On upgrade flag.
        """
        return pulumi.get(self, "on_upgrade")

    @on_upgrade.setter
    def on_upgrade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_upgrade", value)

    @property
    @pulumi.getter(name="removeIds")
    def remove_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Remove IDs.
        """
        return pulumi.get(self, "remove_ids")

    @remove_ids.setter
    def remove_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "remove_ids", value)

    @property
    @pulumi.getter(name="requestTokenSecret")
    def request_token_secret(self) -> Optional[pulumi.Input[str]]:
        """
        Request token secret.
        """
        return pulumi.get(self, "request_token_secret")

    @request_token_secret.setter
    def request_token_secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "request_token_secret", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        User ID.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)


@pulumi.input_type
class _GoodreadsBookshelvesState:
    def __init__(__self__, *,
                 access_token: Optional[pulumi.Input[str]] = None,
                 access_token_secret: Optional[pulumi.Input[str]] = None,
                 add_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 include_health_warnings: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 on_author_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete_for_upgrade: Optional[pulumi.Input[bool]] = None,
                 on_release_import: Optional[pulumi.Input[bool]] = None,
                 on_upgrade: Optional[pulumi.Input[bool]] = None,
                 remove_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 request_token_secret: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GoodreadsBookshelves resources.
        :param pulumi.Input[str] access_token: Access token.
        :param pulumi.Input[str] access_token_secret: Access token secret.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] add_ids: Add IDs.
        :param pulumi.Input[bool] include_health_warnings: Include health warnings.
        :param pulumi.Input[str] name: Notification name.
        :param pulumi.Input[bool] on_author_delete: On author deleted flag.
        :param pulumi.Input[bool] on_book_delete: On book delete flag.
        :param pulumi.Input[bool] on_book_file_delete: On book file delete flag.
        :param pulumi.Input[bool] on_book_file_delete_for_upgrade: On book file delete for upgrade flag.
        :param pulumi.Input[bool] on_release_import: On release import flag.
        :param pulumi.Input[bool] on_upgrade: On upgrade flag.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remove_ids: Remove IDs.
        :param pulumi.Input[str] request_token_secret: Request token secret.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[str] user_id: User ID.
        :param pulumi.Input[str] username: Username.
        """
        if access_token is not None:
            pulumi.set(__self__, "access_token", access_token)
        if access_token_secret is not None:
            pulumi.set(__self__, "access_token_secret", access_token_secret)
        if add_ids is not None:
            pulumi.set(__self__, "add_ids", add_ids)
        if include_health_warnings is not None:
            pulumi.set(__self__, "include_health_warnings", include_health_warnings)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if on_author_delete is not None:
            pulumi.set(__self__, "on_author_delete", on_author_delete)
        if on_book_delete is not None:
            pulumi.set(__self__, "on_book_delete", on_book_delete)
        if on_book_file_delete is not None:
            pulumi.set(__self__, "on_book_file_delete", on_book_file_delete)
        if on_book_file_delete_for_upgrade is not None:
            pulumi.set(__self__, "on_book_file_delete_for_upgrade", on_book_file_delete_for_upgrade)
        if on_release_import is not None:
            pulumi.set(__self__, "on_release_import", on_release_import)
        if on_upgrade is not None:
            pulumi.set(__self__, "on_upgrade", on_upgrade)
        if remove_ids is not None:
            pulumi.set(__self__, "remove_ids", remove_ids)
        if request_token_secret is not None:
            pulumi.set(__self__, "request_token_secret", request_token_secret)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="accessToken")
    def access_token(self) -> Optional[pulumi.Input[str]]:
        """
        Access token.
        """
        return pulumi.get(self, "access_token")

    @access_token.setter
    def access_token(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_token", value)

    @property
    @pulumi.getter(name="accessTokenSecret")
    def access_token_secret(self) -> Optional[pulumi.Input[str]]:
        """
        Access token secret.
        """
        return pulumi.get(self, "access_token_secret")

    @access_token_secret.setter
    def access_token_secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_token_secret", value)

    @property
    @pulumi.getter(name="addIds")
    def add_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Add IDs.
        """
        return pulumi.get(self, "add_ids")

    @add_ids.setter
    def add_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "add_ids", value)

    @property
    @pulumi.getter(name="includeHealthWarnings")
    def include_health_warnings(self) -> Optional[pulumi.Input[bool]]:
        """
        Include health warnings.
        """
        return pulumi.get(self, "include_health_warnings")

    @include_health_warnings.setter
    def include_health_warnings(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "include_health_warnings", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Notification name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="onAuthorDelete")
    def on_author_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        On author deleted flag.
        """
        return pulumi.get(self, "on_author_delete")

    @on_author_delete.setter
    def on_author_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_author_delete", value)

    @property
    @pulumi.getter(name="onBookDelete")
    def on_book_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        On book delete flag.
        """
        return pulumi.get(self, "on_book_delete")

    @on_book_delete.setter
    def on_book_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_book_delete", value)

    @property
    @pulumi.getter(name="onBookFileDelete")
    def on_book_file_delete(self) -> Optional[pulumi.Input[bool]]:
        """
        On book file delete flag.
        """
        return pulumi.get(self, "on_book_file_delete")

    @on_book_file_delete.setter
    def on_book_file_delete(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_book_file_delete", value)

    @property
    @pulumi.getter(name="onBookFileDeleteForUpgrade")
    def on_book_file_delete_for_upgrade(self) -> Optional[pulumi.Input[bool]]:
        """
        On book file delete for upgrade flag.
        """
        return pulumi.get(self, "on_book_file_delete_for_upgrade")

    @on_book_file_delete_for_upgrade.setter
    def on_book_file_delete_for_upgrade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_book_file_delete_for_upgrade", value)

    @property
    @pulumi.getter(name="onReleaseImport")
    def on_release_import(self) -> Optional[pulumi.Input[bool]]:
        """
        On release import flag.
        """
        return pulumi.get(self, "on_release_import")

    @on_release_import.setter
    def on_release_import(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_release_import", value)

    @property
    @pulumi.getter(name="onUpgrade")
    def on_upgrade(self) -> Optional[pulumi.Input[bool]]:
        """
        On upgrade flag.
        """
        return pulumi.get(self, "on_upgrade")

    @on_upgrade.setter
    def on_upgrade(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "on_upgrade", value)

    @property
    @pulumi.getter(name="removeIds")
    def remove_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Remove IDs.
        """
        return pulumi.get(self, "remove_ids")

    @remove_ids.setter
    def remove_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "remove_ids", value)

    @property
    @pulumi.getter(name="requestTokenSecret")
    def request_token_secret(self) -> Optional[pulumi.Input[str]]:
        """
        Request token secret.
        """
        return pulumi.get(self, "request_token_secret")

    @request_token_secret.setter
    def request_token_secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "request_token_secret", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        User ID.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)

    @property
    @pulumi.getter
    def username(self) -> Optional[pulumi.Input[str]]:
        """
        Username.
        """
        return pulumi.get(self, "username")

    @username.setter
    def username(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "username", value)


class GoodreadsBookshelves(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_token: Optional[pulumi.Input[str]] = None,
                 access_token_secret: Optional[pulumi.Input[str]] = None,
                 add_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 include_health_warnings: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 on_author_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete_for_upgrade: Optional[pulumi.Input[bool]] = None,
                 on_release_import: Optional[pulumi.Input[bool]] = None,
                 on_upgrade: Optional[pulumi.Input[bool]] = None,
                 remove_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 request_token_secret: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        <!-- subcategory:Notifications -->Notification GoodreadsBookshelves resource.
        For more information refer to [Notification](https://wiki.servarr.com/readarr/settings#connect) and [GoodreadsBookshelves](https://wiki.servarr.com/readarr/supported#goodreadsbookshelf).

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import readarr:Notifications/goodreadsBookshelves:GoodreadsBookshelves example 1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_token: Access token.
        :param pulumi.Input[str] access_token_secret: Access token secret.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] add_ids: Add IDs.
        :param pulumi.Input[bool] include_health_warnings: Include health warnings.
        :param pulumi.Input[str] name: Notification name.
        :param pulumi.Input[bool] on_author_delete: On author deleted flag.
        :param pulumi.Input[bool] on_book_delete: On book delete flag.
        :param pulumi.Input[bool] on_book_file_delete: On book file delete flag.
        :param pulumi.Input[bool] on_book_file_delete_for_upgrade: On book file delete for upgrade flag.
        :param pulumi.Input[bool] on_release_import: On release import flag.
        :param pulumi.Input[bool] on_upgrade: On upgrade flag.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remove_ids: Remove IDs.
        :param pulumi.Input[str] request_token_secret: Request token secret.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[str] user_id: User ID.
        :param pulumi.Input[str] username: Username.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GoodreadsBookshelvesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        <!-- subcategory:Notifications -->Notification GoodreadsBookshelves resource.
        For more information refer to [Notification](https://wiki.servarr.com/readarr/settings#connect) and [GoodreadsBookshelves](https://wiki.servarr.com/readarr/supported#goodreadsbookshelf).

        ## Import

        import using the API/UI ID

        ```sh
         $ pulumi import readarr:Notifications/goodreadsBookshelves:GoodreadsBookshelves example 1
        ```

        :param str resource_name: The name of the resource.
        :param GoodreadsBookshelvesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GoodreadsBookshelvesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_token: Optional[pulumi.Input[str]] = None,
                 access_token_secret: Optional[pulumi.Input[str]] = None,
                 add_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 include_health_warnings: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 on_author_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete: Optional[pulumi.Input[bool]] = None,
                 on_book_file_delete_for_upgrade: Optional[pulumi.Input[bool]] = None,
                 on_release_import: Optional[pulumi.Input[bool]] = None,
                 on_upgrade: Optional[pulumi.Input[bool]] = None,
                 remove_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 request_token_secret: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 username: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GoodreadsBookshelvesArgs.__new__(GoodreadsBookshelvesArgs)

            if access_token is None and not opts.urn:
                raise TypeError("Missing required property 'access_token'")
            __props__.__dict__["access_token"] = None if access_token is None else pulumi.Output.secret(access_token)
            if access_token_secret is None and not opts.urn:
                raise TypeError("Missing required property 'access_token_secret'")
            __props__.__dict__["access_token_secret"] = None if access_token_secret is None else pulumi.Output.secret(access_token_secret)
            __props__.__dict__["add_ids"] = add_ids
            __props__.__dict__["include_health_warnings"] = include_health_warnings
            __props__.__dict__["name"] = name
            __props__.__dict__["on_author_delete"] = on_author_delete
            __props__.__dict__["on_book_delete"] = on_book_delete
            __props__.__dict__["on_book_file_delete"] = on_book_file_delete
            __props__.__dict__["on_book_file_delete_for_upgrade"] = on_book_file_delete_for_upgrade
            __props__.__dict__["on_release_import"] = on_release_import
            __props__.__dict__["on_upgrade"] = on_upgrade
            __props__.__dict__["remove_ids"] = remove_ids
            __props__.__dict__["request_token_secret"] = None if request_token_secret is None else pulumi.Output.secret(request_token_secret)
            __props__.__dict__["tags"] = tags
            __props__.__dict__["user_id"] = user_id
            if username is None and not opts.urn:
                raise TypeError("Missing required property 'username'")
            __props__.__dict__["username"] = username
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["accessToken", "accessTokenSecret", "requestTokenSecret"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(GoodreadsBookshelves, __self__).__init__(
            'readarr:Notifications/goodreadsBookshelves:GoodreadsBookshelves',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_token: Optional[pulumi.Input[str]] = None,
            access_token_secret: Optional[pulumi.Input[str]] = None,
            add_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            include_health_warnings: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            on_author_delete: Optional[pulumi.Input[bool]] = None,
            on_book_delete: Optional[pulumi.Input[bool]] = None,
            on_book_file_delete: Optional[pulumi.Input[bool]] = None,
            on_book_file_delete_for_upgrade: Optional[pulumi.Input[bool]] = None,
            on_release_import: Optional[pulumi.Input[bool]] = None,
            on_upgrade: Optional[pulumi.Input[bool]] = None,
            remove_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            request_token_secret: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            user_id: Optional[pulumi.Input[str]] = None,
            username: Optional[pulumi.Input[str]] = None) -> 'GoodreadsBookshelves':
        """
        Get an existing GoodreadsBookshelves resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_token: Access token.
        :param pulumi.Input[str] access_token_secret: Access token secret.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] add_ids: Add IDs.
        :param pulumi.Input[bool] include_health_warnings: Include health warnings.
        :param pulumi.Input[str] name: Notification name.
        :param pulumi.Input[bool] on_author_delete: On author deleted flag.
        :param pulumi.Input[bool] on_book_delete: On book delete flag.
        :param pulumi.Input[bool] on_book_file_delete: On book file delete flag.
        :param pulumi.Input[bool] on_book_file_delete_for_upgrade: On book file delete for upgrade flag.
        :param pulumi.Input[bool] on_release_import: On release import flag.
        :param pulumi.Input[bool] on_upgrade: On upgrade flag.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remove_ids: Remove IDs.
        :param pulumi.Input[str] request_token_secret: Request token secret.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] tags: List of associated tags.
        :param pulumi.Input[str] user_id: User ID.
        :param pulumi.Input[str] username: Username.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GoodreadsBookshelvesState.__new__(_GoodreadsBookshelvesState)

        __props__.__dict__["access_token"] = access_token
        __props__.__dict__["access_token_secret"] = access_token_secret
        __props__.__dict__["add_ids"] = add_ids
        __props__.__dict__["include_health_warnings"] = include_health_warnings
        __props__.__dict__["name"] = name
        __props__.__dict__["on_author_delete"] = on_author_delete
        __props__.__dict__["on_book_delete"] = on_book_delete
        __props__.__dict__["on_book_file_delete"] = on_book_file_delete
        __props__.__dict__["on_book_file_delete_for_upgrade"] = on_book_file_delete_for_upgrade
        __props__.__dict__["on_release_import"] = on_release_import
        __props__.__dict__["on_upgrade"] = on_upgrade
        __props__.__dict__["remove_ids"] = remove_ids
        __props__.__dict__["request_token_secret"] = request_token_secret
        __props__.__dict__["tags"] = tags
        __props__.__dict__["user_id"] = user_id
        __props__.__dict__["username"] = username
        return GoodreadsBookshelves(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessToken")
    def access_token(self) -> pulumi.Output[str]:
        """
        Access token.
        """
        return pulumi.get(self, "access_token")

    @property
    @pulumi.getter(name="accessTokenSecret")
    def access_token_secret(self) -> pulumi.Output[str]:
        """
        Access token secret.
        """
        return pulumi.get(self, "access_token_secret")

    @property
    @pulumi.getter(name="addIds")
    def add_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        Add IDs.
        """
        return pulumi.get(self, "add_ids")

    @property
    @pulumi.getter(name="includeHealthWarnings")
    def include_health_warnings(self) -> pulumi.Output[bool]:
        """
        Include health warnings.
        """
        return pulumi.get(self, "include_health_warnings")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Notification name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="onAuthorDelete")
    def on_author_delete(self) -> pulumi.Output[bool]:
        """
        On author deleted flag.
        """
        return pulumi.get(self, "on_author_delete")

    @property
    @pulumi.getter(name="onBookDelete")
    def on_book_delete(self) -> pulumi.Output[bool]:
        """
        On book delete flag.
        """
        return pulumi.get(self, "on_book_delete")

    @property
    @pulumi.getter(name="onBookFileDelete")
    def on_book_file_delete(self) -> pulumi.Output[bool]:
        """
        On book file delete flag.
        """
        return pulumi.get(self, "on_book_file_delete")

    @property
    @pulumi.getter(name="onBookFileDeleteForUpgrade")
    def on_book_file_delete_for_upgrade(self) -> pulumi.Output[bool]:
        """
        On book file delete for upgrade flag.
        """
        return pulumi.get(self, "on_book_file_delete_for_upgrade")

    @property
    @pulumi.getter(name="onReleaseImport")
    def on_release_import(self) -> pulumi.Output[bool]:
        """
        On release import flag.
        """
        return pulumi.get(self, "on_release_import")

    @property
    @pulumi.getter(name="onUpgrade")
    def on_upgrade(self) -> pulumi.Output[bool]:
        """
        On upgrade flag.
        """
        return pulumi.get(self, "on_upgrade")

    @property
    @pulumi.getter(name="removeIds")
    def remove_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        Remove IDs.
        """
        return pulumi.get(self, "remove_ids")

    @property
    @pulumi.getter(name="requestTokenSecret")
    def request_token_secret(self) -> pulumi.Output[str]:
        """
        Request token secret.
        """
        return pulumi.get(self, "request_token_secret")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Sequence[int]]:
        """
        List of associated tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Output[str]:
        """
        User ID.
        """
        return pulumi.get(self, "user_id")

    @property
    @pulumi.getter
    def username(self) -> pulumi.Output[str]:
        """
        Username.
        """
        return pulumi.get(self, "username")

